// Header File
// Created 20.02.2008; 18:09:51

#ifndef GAME_H
#define GAME_H


#define LEVEL_BACKGROUND_HEIGHT 108


char *status_bar;

#define STATUS_BAR_HEIGHT     20
#define STATUS_BAR_BYTE_WIDTH 30


struct {
	volatile unsigned char running : 1;
	volatile unsigned char counter : 5;
	volatile unsigned char seconds : 6;
	volatile unsigned char minutes : 6;
} clock;


unsigned char *background;



typedef struct {
	unsigned char active;
	unsigned char id;
	short x, y;
	unsigned short counter;	//	used for different purposes
} OBJECT;

//unsigned char constant_object_nr;
/*
OBJECT *constant_objects;

unsigned char random_object_nr;
OBJECT *random_objects;*/


unsigned short constant_objects_offset;
unsigned short random_object_sets_offset;


#define COORD_SHIFT 7


unsigned long money, goal;


OBJECT *objects;
unsigned char object_nr;


//enum WinchStatus {W_OPEN,W_CLOSED};
/*ANIMATION*/ SPRITE winch_sprt[2] = {
	/*{*/{_winch_open,   15, 2, 16}, /*19},*/
	/*{*/{_winch_closed, 16, 2, 16}, /*19},*/
};

unsigned char *winch_open, *winch_closed;


struct {
	unsigned char  mode;
	         short angle;
	unsigned short length;
	//unsigned short strength;
	//unsigned short radius;
	unsigned char  direction;
	unsigned char  power_ups;
	OBJECT *object;
} winch;

//	values that 'winch.mode' can take
enum WinchModes {W_UP, W_DOWN, W_SWINGING};

#define WINCH_DEFAULT_LENGTH		 (20 << COORD_SHIFT)
#define WINCH_DEFAULT_RADIUS		  8
#define WINCH_DEFAULT_SPEED			400	//2*COORD_SHIFT
#define WINCH_EMPTY_SPEED				800
#define WINCH_DEFAULT_ANGLE_INC   4
#define WINCH_DEFAULT_STRENGTH	500

//#define WINCH_STRENGTH_ADD			100
#define WINCH_EXTRA_STRENGTH		WINCH_DEFAULT_STRENGTH + 100
//#define WINCH_RADIUS_ADD				  4
#define WINCH_EXTRA_RADIUS			WINCH_DEFAULT_RADIUS + 2

short winch_default_coords[2] = {(LCD_WIDTH >> 1) << COORD_SHIFT, (10) << COORD_SHIFT};


#define OBJECT_MIN_Y	STATUS_BAR_HEIGHT
#define OBJECT_MIN_DIST	60
#define MIN_ANGLE	10

//	update indicators
//unsigned char u_money, u_
struct {
					 unsigned char money   : 1;
					 unsigned char goal    : 1;
	volatile unsigned char minutes : 1;
	volatile unsigned char seconds : 1;
					 unsigned char level   : 1;
					 unsigned char anim    : 1;
					 unsigned char unused_ : 2;
} update;

unsigned char lvlnum;

enum GameModes {G_NORMAL, G_RANDOM};
unsigned char game_mode;

#define RANDOM_MODE_MIN_OBJECTS	 5
#define RANDOM_MODE_MAX_OBJECTS	30
//#define RANDOM_MODE_MAX_GOAL		10000

#define SINK_CHANCE_FACTOR	1
#define SINK_FACTOR					1


const SPRITE dynamite_sprts[2] = {{_dynamite_1, 3, 1, 15},{_dynamite_2, 8, 1, 15}};

//unsigned char dynamites;

short dynamite_default_coords[2] = {((LCD_WIDTH >> 1) + 30) << COORD_SHIFT, (2) << COORD_SHIFT};

#define DYNAMITE_THROW_SPEED	5
//#define DYNAMITE_THROW_RADIUS	4

#define MAX_DYNAMITES	12	//15	//10



//	used for sinking counter
#define HIGH_WEIGHT	500




const ANIMATION explosions[2] = {
	{{_explosion_1, 16, 2, 24}, 4},
	{{_explosion_2, 32, 4, 32}, 8},
};


//#define TINDERBOX_STEP_NR	8

#define TINDERBOX_STEP_SHIFT	2

enum Explosions {E_DYNAMITE, E_TINDERBOX};

#define TINDERBOX_EXPLOSION_RADIUS	30	//32


const SPRITE tinderbox_cover_sprt = {_tinderbox_cover, 16, 2, 10};


#define PIG_MIN_COUNT	 10
#define PIG_MAX_COUNT	100
#define PIG_SPEED			128

enum PigModes {P_WALKING, P_WAITING};


#define TITLE_BYTE_WIDTH	18
#define TITLE_HEIGHT			20

#define TITLE_PIC_BYTE_WIDTH	 20
#define TITLE_PIC_HEIGHT			120



//#define ITEM_PIC_BYTE_WIDTH	16
#define ITEM_PIC_HEIGHT			34

//unsigned char *shop_items_sprt;


//	bit occupation in winch.power_ups
//	4 bits for dynamites (max 16)
enum PowerUps {
	P_DYNAMITE = 0, 
	P_STRENGTH_DRINK = 7, 
	P_LUCKY_CLOVER = 6, 
	P_ROCK_BOOK = 5, 
	P_DIAMOND_POLISH = 4
};


#define P_ROCK_VALUE_ADD_FACTOR	  3
#define P_DIAMONT_VALUE_ADD			300
#define P_LUCKY_CLOVER_ADD			200


unsigned short delay;



#define MAX_HISCORES 9
#define MAX_NAME_LENGTH 10

typedef struct {
	char name[MAX_NAME_LENGTH+1];
	unsigned long score;
} HISCORE;

HISCORE *hiscore;


#define SAVE_FILE_NAME	(const char *)"main\\goldsave"
#define SAVE_FILE_EXT		(const char *)"SAVE"
#define SAVE_FILE_SIZE	(MAX_HISCORES * sizeof(HISCORE) + 2 + 1)


#endif