// C Source File
// Created 20.02.2008; 17:57:35


#include "standart.h"


DEFINE_INT_HANDLER (CLOCK_TIMER) {
	if(clock.running) {
		if(clock.counter) {
			--clock.counter;
		} else {
			if(clock.seconds) {
				--clock.seconds;
			} else {
				if(clock.minutes) {
					--clock.minutes;
					clock.seconds = 59;
					update.minutes = TRUE;
				} else {
					clock.running = 0;
				}
			}
			clock.counter = 19;
			update.seconds = TRUE;
		}
	}
};

/* AUTO_INT_1 und AUTO_INT_5 speichern */ 
inline void saveAutoInts(INT_HANDLER *savint1, INT_HANDLER *savint5) 
{ 
    /* Handler speichern */ 
    *savint1 = GetIntVec(AUTO_INT_1);
    *savint5 = GetIntVec(AUTO_INT_5);

    /* Handler umlenken */ 
    SetIntVec(AUTO_INT_1, DUMMY_HANDLER); 
    SetIntVec(AUTO_INT_5, CLOCK_TIMER); 
} 

/* AUTO_INT_1 und AUTO_INT_5 wieder herstellen */ 
inline void restoreAutoInts(INT_HANDLER savint1, INT_HANDLER savint5) 
{ 
    /* Handler wieder herstellen */ 
    SetIntVec(AUTO_INT_1, savint1);
    SetIntVec(AUTO_INT_5, savint5);
}

// Main Function
void _main(void)
{
	if(!SetupCharSet()) return;
	
	//	init random number generator
	randomize();
	
	//	allocate space
	if(!(LcdBuffer = malloc(
		3*LCD_SIZE+
		(STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT << 1)+
		BUF_STR_SIZE+
		(30 * LEVEL_BACKGROUND_HEIGHT << 1)+
		winch_sprt[0].byte_width*winch_sprt[0].height*3*19+
		winch_sprt[1].byte_width*winch_sprt[1].height*3*19
		//+
		//(ITEM_PIC_BYTE_WIDTH * ITEM_PIC_HEIGHT << 1)
		))) {
		ST_helpMsg("Memory allocation failed!");
		return;
	}
	
	LightBuffer = LcdBuffer + LCD_SIZE;
	
	DarkBuffer = LcdBuffer + 2 * LCD_SIZE;
	
	void *offset = LcdBuffer + 3 * LCD_SIZE;
	status_bar = offset;
	offset += STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT << 1;
	buf_str = offset;
	offset += BUF_STR_SIZE;
	background = offset;
	offset += 30 * LEVEL_BACKGROUND_HEIGHT << 1;
	winch_open = offset;
	offset += winch_sprt[0].byte_width*winch_sprt[0].height*3*19;
	winch_closed = offset;
	offset += winch_sprt[1].byte_width*winch_sprt[1].height*3*19;
	//shop_items_sprt = offset;
	//offset += ITEM_PIC_BYTE_WIDTH * ITEM_PIC_HEIGHT << 1;
	
	//	save screen
	memcpy(LcdBuffer, LCD_MEM, LCD_SIZE);
	
	clock.running = clock.counter = clock.seconds = clock.minutes = 0;
	
	saveAutoInts(&saveint1, &saveint5);
	
	if(!GrayOn()) {
		restoreAutoInts(saveint1, saveint5);
		
		//restore screen
		memcpy(LCD_MEM, LcdBuffer, LCD_SIZE);
		free(LcdBuffer);
		ST_helpMsg("Memory allocation failed!");
		return;
	}
	
	LightPlane = GrayGetPlane(LIGHT_PLANE);
	DarkPlane  = GrayGetPlane(DARK_PLANE);
	
	
	
	Error = ERR_NONE;
	
	//ResetClock();
	
	//	load shop item picture
	//DecompRLEVert(_shop_items_l, shop_items_sprt, ITEM_PIC_BYTE_WIDTH, ITEM_PIC_HEIGHT);
	//DecompRLEVert(_shop_items_d, shop_items_sprt+ITEM_PIC_BYTE_WIDTH * ITEM_PIC_HEIGHT, ITEM_PIC_BYTE_WIDTH, ITEM_PIC_HEIGHT);
	
	
	InitStatusBar();
	
	
	//	rotate winch sprites:
	unsigned char i, j;
	
	//	open
	for(i = 0; i <= 18; ++i) {
		RotateSprite16_R(((unsigned short *)winch_sprt[0].data)+0*winch_sprt[0].height,((unsigned short *)winch_open)+(i*3+0)*winch_sprt[0].height,winch_sprt[0].height,winch_sprt[0].width >> 1,winch_sprt[0].height >> 1,10*i+270);
		RotateSprite16_R(((unsigned short *)winch_sprt[0].data)+1*winch_sprt[0].height,((unsigned short *)winch_open)+(i*3+1)*winch_sprt[0].height,winch_sprt[0].height,winch_sprt[0].width >> 1,winch_sprt[0].height >> 1,10*i+270);
		for(j = 0; j < winch_sprt[0].height; ++j) {
			*(((unsigned short *)winch_open)+(i*3+2)*winch_sprt[0].height+j) = 
				~(*(((unsigned short *)winch_open)+(i*3+0)*winch_sprt[0].height+j) |
					*(((unsigned short *)winch_open)+(i*3+1)*winch_sprt[0].height+j));
		}
	}
	
	//	closed
	for(i = 0; i <= 18; ++i) {
		RotateSprite16_R(((unsigned short *)winch_sprt[1].data)+0*winch_sprt[1].height,((unsigned short *)winch_closed)+(i*3+0)*winch_sprt[1].height,winch_sprt[1].height,winch_sprt[1].width >> 1,winch_sprt[1].height >> 1,10*i+270);
		RotateSprite16_R(((unsigned short *)winch_sprt[1].data)+1*winch_sprt[1].height,((unsigned short *)winch_closed)+(i*3+1)*winch_sprt[1].height,winch_sprt[1].height,winch_sprt[1].width >> 1,winch_sprt[1].height >> 1,10*i+270);
		for(j = 0; j < winch_sprt[1].height; ++j) {
			*(((unsigned short *)winch_closed)+(i*3+2)*winch_sprt[1].height+j) = 
				~(*(((unsigned short *)winch_closed)+(i*3+0)*winch_sprt[1].height+j) |
					*(((unsigned short *)winch_closed)+(i*3+1)*winch_sprt[1].height+j));
		}
	}
	
	/*game_mode = G_RANDOM;
	//game_mode = G_NORMAL;
	
	delay = 500;*/
	
	if(LoadGameData()) {
		Menu();
		//Game();
		SaveGameData();
	}
	
	
	
	if(Error != FAST_QUIT) {
		Dissolve(LightPlane, DarkPlane, LcdBuffer, LcdBuffer);
	}
	
	GrayOff();
	
	//memcpy(LCD_MEM, LcdBuffer, LCD_SIZE);
	FastCopyScreen_R(LcdBuffer, LCD_MEM);
	
	restoreAutoInts(saveint1, saveint5);
	
	free(LcdBuffer);
	
	if(Error == ERR_NONE) {
		ST_helpMsg(status_message[random(STATUS_MESSAGE_NR)]);
	} else if(Error == FAST_QUIT) {
		ST_helpMsg("Don't let the teacher catch you ;-)");
	} else if(Error == ERR_MEM) {
		ST_helpMsg("Memory allocation failed!");
	}
}