// C Source File
// Created 04.03.2008; 15:22:05

#include "standart.h"


#define MENU_OPTION_NR 6

const char *menu_lines[MENU_OPTION_NR] = {
	"Start",
	"Options",
	"Highscores",
	"Help",
	"About",
	"Exit",
};

void Menu() {
	unsigned char cursor = 0, exit, dissolve = 1;
	do {
		//clear virtual screens
		GrayClearScreen2B_R(LightBuffer, DarkBuffer);
		
		//clear screens
		//GrayClearScreen2B_R(LightPlane, DarkPlane);
		
		
		//	draw title picture
		SpriteX8_OR_R(LCD_WIDTH - (TITLE_PIC_BYTE_WIDTH << 3),
			LCD_HEIGHT-TITLE_PIC_HEIGHT,TITLE_PIC_HEIGHT,
			_title_pic_l,
			TITLE_PIC_BYTE_WIDTH,
			LightBuffer);
		SpriteX8_OR_R(LCD_WIDTH - (TITLE_PIC_BYTE_WIDTH << 3),
			LCD_HEIGHT-TITLE_PIC_HEIGHT,TITLE_PIC_HEIGHT,
			_title_pic_d,
			TITLE_PIC_BYTE_WIDTH,
			DarkBuffer);
		
		
		//	draw title
		SpriteX8_MASK_R((LCD_WIDTH - (TITLE_BYTE_WIDTH << 3)) >> 1,
			10,TITLE_HEIGHT,
			_title_l,_title_m,
			TITLE_BYTE_WIDTH,
			LightBuffer);
		SpriteX8_MASK_R((LCD_WIDTH - (TITLE_BYTE_WIDTH << 3)) >> 1,
			10,TITLE_HEIGHT,
			_title_d,_title_m,
			TITLE_BYTE_WIDTH,
			DarkBuffer);
		
		//FS_GrayDrawString( 3, 4, "Start - Enter",   A_NORMAL|A_SHADOWED, F_4x6);
		//FS_GrayDrawString( 3, 4, "Instructions - F1",   A_NORMAL|A_SHADOWED, F_4x6);
		
		unsigned char i;
		for(i = 0; i < MENU_OPTION_NR; ++i) {
			FS_GrayDrawString(14,50+11*i, menu_lines[i], A_NORMAL|A_SHADOWED, F_8x10);
		}
		
		
		//unsigned char cursor = 0, exit = 0;
		exit = 0;
		
		do {
			if(dissolve) {
				dissolve = 0;
				Dissolve(LightPlane, DarkPlane, LightBuffer, DarkBuffer);
			} else {
				Display();
			}
			
			GraySprite8_OR_R(4,50+11*cursor,8,_menu_cursor,_menu_cursor+8,LightPlane,DarkPlane);
			
			while(_rowread(0)) {
				HandleTeacherKeys();
			}
			if(Error != ERR_NONE) {
				break;
			}
			while(!_rowread(0));
			
			//HandleTeacherKeys();
			
			if(_keytest(RR_UP)) {
				if(cursor) {
					--cursor;
				} else {
					cursor = MENU_OPTION_NR-1;
				}
			}
			if(_keytest(RR_DOWN)) {
				if(cursor < MENU_OPTION_NR-1) {
					++cursor;
				} else {
					cursor = 0;
				}
			}
			if(_keytest(RR_MINUS)) {
				OSContrastDn();
			} 
			if(_keytest(RR_PLUS)) {
				OSContrastUp();
			}
			if(_keytest(RR_ENTER)||_keytest(RR_ENTER2)||_keytest(RR_HAND)) {
				exit = 1;	//+(cursor == MENU_OPTION_NR-1);
				/*if(cursor == MENU_OPTION_NR-1) {
					exit = 2;
				} else {
					exit = 1;
				}*/
			}
			if(_keytest(RR_ESC)) {
				cursor = MENU_OPTION_NR-1;
				exit = 1;
			}
			
		} while(!exit /*&& Error == ERR_NONE*/	/*|| _rowread(0)*/);
		
		while(_rowread(0));
		
		if(Error == ERR_NONE) {
			switch(cursor) {
				case 0:
					Game();
					if(Error == ERR_NONE) {
						Highscores();
					}
					break;
				case 1:
					Options();
					break;
				case 2:
					Highscores();
					break;
				case 3:
					//Help();
					Information(0);
					Information(1);
					Information(2);
					break;
				case 4:
					//About();
					Information(3);
					break;
				case 5:
					exit = 2;
			}
		}
		
		dissolve = 1;
		
		if(Error != ERR_NONE) {
			exit = 2;
		}
	} while(exit != 2);
	
	//WaitKey();
}

#define HELP_TEXTS	3
const unsigned char *help_texts[HELP_TEXTS] = {
	"Use your claw and reel to mine gold and other treasures out
of the earth. Your claw will swing back and forth. Press the
down arrow to lower it. Once it has grabbed something it 
will reel it up. Heavy objects like rocks and large pieces 
of gold will be harder to reel up. Grab bags contain random 
amount of money, a strength power-up or a stick of dynamite.
Clocks give extra time. Between levels you can buy items 
that can help you. Collect the target amount of money by the
end of the level. If you don't meet your goal by the end of 
the level, the game will be over. Your money carries over 
from one level to the next. If you accidentally blow up 
everything  on a level or just feel like going on, you can 
press APPS to finish the level. If you haven't met your goal
the game will be over."
,
	"If you don't want to reel up an item that your claw grabbed,
you can throw a dynamite at it (if you have one) to blow it up.
This can be useful if you grabbed a heavy roch and there isn't
much time left: Explode it and grab something lightweight.
Be careful with the tinderboxes: If you grab one, it 
explodes and also blasts other items around it 
(especially other tinderboxes).

~~~ TIPS ~~~
Try to grab the big nuggets first otherwise they will sink down
soon due to their high weight. Look after the small pigs: 
They walk around to aggravate to get somethink valuable.
Be careful when aiming: Grabbing a tinderbox might start a
series of explosions so that you loose much items of the level"
,
	"- Game -
Down - Lower claw
Hand - Throw dynamite
Escape - Menu
/ / * - Adjust Speed

- Menu / Shop -
Arrows - Move Cursor
Hand / Enter - Select

- General -
+ / - - Adjust Contrast
Clear - Teachermode
2nd + Clear - Turn Calc Off
Diamond + Clear - Fast Quit"
};

// powered by ExtGraph v2.005
// EXTGRAPH_VERSION_PWDSTR
const unsigned char about_text[] = 
COMMENT_PROGRAM_NAME " " COMMENT_VERSION_STRING	" Copyright () 2008
by Boscop, member of BoolSoft
http://www.boolsoft.org/

For bug reports, comments, questions
or suggestions email me at: boscop@boolsoft.org

Compiled with TIGCC 0.96 8,
powered by ExtGraph v2.005
Sprites converted with ImageStudio
Thanks to Technoplaza and BoolSoft's members.";

void Information(unsigned char i) {
	unsigned short l = 0;
	unsigned char j, lines = 0, exit = 0;
	char line[60];
	
	const char *text = (i == HELP_TEXTS ? about_text : help_texts[i]);
	
	//clear virtual screens
	//GrayClearScreen2B_R(LightBuffer, DarkBuffer);
	
	//FastFillRect_R(LightBuffer,,y,x+width-1,y+DRAW_HEIGHT-1,A_XOR);
	FastFillScreen_R(LightBuffer);
	FastFillScreen_R(DarkBuffer);
	GrayFastFillRect_R(LightBuffer,DarkBuffer,10,8,LCD_WIDTH-1-10,LCD_HEIGHT-1-8,COLOR_LIGHTGRAY);
	
	FS_GrayDrawString(0,16,
		(i == HELP_TEXTS ? "ABOUT" : (i == HELP_TEXTS - 1 ? "KEYS" : "HELP")),
		A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
	
	do {
		for(j = 0; text[l+j] != '\n' && text[l+j] != 0; ++j) {
			line[j] = text[l+j];
		}
		line[j] = 0;
		if(text[l+j] == 0) {
			exit = 1;
		} else {
			l += strlen(line)+1;
		}
		++lines;
		FS_GrayDrawString(0,24+(i == HELP_TEXTS ? 8 : 6)*lines,line,A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
	} while(!exit);
	
	Display();
	//WaitKey();
	while(_rowread(0));
	while(!_rowread(0));
	while(_rowread(0)) {
		HandleTeacherKeys();
	}
}

#define OPTION_NR	2
/*const unsigned char *option_texts[OPTION_NR] = {
	"Mode",
	"Speed",
};

const unsigned char *option_choices[OPTION_NR] = {
	"Normal","Random",
	"1","2","3","4","5","6","7","8","9","10",
};

const unsigned char option_max[OPTION_NR] = {
	2,
	10,
}*/


void Options() {
	unsigned char exit = 0, cursor = 0;
	delay = (1000 - (delay > 1000 ? 1000 : delay)) / 100;
	do {
		FastFillScreen_R(LightBuffer);
		FastFillScreen_R(DarkBuffer);
		GrayFastFillRect_R(LightBuffer,DarkBuffer,10,8,LCD_WIDTH-1-10,LCD_HEIGHT-1-8,COLOR_LIGHTGRAY);
		
		FS_GrayDrawString(0,16,"OPTIONS",A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
		
		//	draw texts
		FS_GrayDrawString(70,50,"Mode:",A_NORMAL|A_SHADOWED,F_8x10);
		FS_GrayDrawString(70,70,"Speed:",A_NORMAL|A_SHADOWED,F_8x10);
		
		FS_GrayDrawString(120,50,(game_mode == G_NORMAL ? "Normal" : "Random"),A_NORMAL|A_SHADOWED,F_8x10);
		FS_GrayDrawString(120,70,((const char []){'0' + delay, '\0'}),A_NORMAL|A_SHADOWED,F_8x10);
		
		Display();
		
		//	draw cursor
		GraySprite8_OR_R(60,50+20*cursor,8,_menu_cursor,_menu_cursor+8,LightPlane,DarkPlane);
		
		while(_rowread(0)) {
			HandleTeacherKeys();
		}
		if(Error != ERR_NONE) {
			//delay = 1000 - delay * 100;
			break;
		}
		while(!_rowread(0));
		
		if(_keytest(RR_UP)) {
			if(cursor) {
				--cursor;
			} else {
				cursor = OPTION_NR-1;
			}
		}
		if(_keytest(RR_DOWN)) {
			if(cursor < OPTION_NR-1) {
				++cursor;
			} else {
				cursor = 0;
			}
		}
		if(_keytest(RR_MINUS)) {
			OSContrastDn();
		} 
		if(_keytest(RR_PLUS)) {
			OSContrastUp();
		}
		if(_keytest(RR_ESC) || _keytest(RR_ENTER) || _keytest(RR_ENTER2) || _keytest(RR_HAND)) {
			exit = 1;
		}
		if(_keytest(RR_RIGHT)) {
			if(cursor == 0) {
				game_mode ^= 1;
			} else {
				if(delay < 9) {
					++delay;
				} else {
					delay = 0;
				}
			}
		}
		if(_keytest(RR_LEFT)) {
			if(cursor == 0) {
				game_mode ^= 1;
			} else {
				if(delay > 0) {
					--delay;
				} else {
					delay = 9;
				}
			}
		}
	} while(!exit);
	while(_rowread(0));
	delay = 1000 - delay * 100;
}

void Highscores() {
	unsigned char i;
	
	FastFillScreen_R(LightBuffer);
	FastFillScreen_R(DarkBuffer);
	GrayFastFillRect_R(LightBuffer,DarkBuffer,10,8,LCD_WIDTH-1-10,LCD_HEIGHT-1-8,COLOR_LIGHTGRAY);
	
	FS_GrayDrawString(0,16,"HIGH-SCORES",A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
	
	for(i = 0; i < MAX_HISCORES; ++i) {
		sprintf(buf_str, "%-10s   %07lu", hiscore[i].name, hiscore[i].score);
		FS_GrayDrawString(0,30+10*i,buf_str,A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
	}
	Display();
	
	while(_rowread(0));
	while(!_rowread(0));
	while(_rowread(0)) {
		HandleTeacherKeys();
	}
}