// C Source File
// Created 04.03.2008; 15:21:55

#include "standart.h"


void LoadLevel(/*unsigned char lvlnum*/) {
	#ifdef BACKGROUND
	//	background
	if(game_mode == G_NORMAL) {
		DecompressRLEHorz(backgrounds[levels[lvlnum].background_id][0], 
			background, 30 * LEVEL_BACKGROUND_HEIGHT);
		DecompressRLEHorz(backgrounds[levels[lvlnum].background_id][1],
			background + 30 * LEVEL_BACKGROUND_HEIGHT, 30 * LEVEL_BACKGROUND_HEIGHT);
	} else {
		unsigned char bg = random(BACKGROUND_NR);
		DecompressRLEHorz(backgrounds[bg][0], 
			background, 30 * LEVEL_BACKGROUND_HEIGHT);
		DecompressRLEHorz(backgrounds[bg][1],
			background + 30 * LEVEL_BACKGROUND_HEIGHT, 30 * LEVEL_BACKGROUND_HEIGHT);
	}
	#endif
	
	unsigned char i, j, k, l, collide;
	
	if(game_mode == G_NORMAL) {
		
		//	count objects
		object_nr = levels[lvlnum].constant_objects;
		
		for(i = 0; i < levels[lvlnum].random_object_sets; ++i) {
			object_nr += random_objects[random_object_sets_offset + i].number;
		}
		
		if(!(objects = realloc(objects, object_nr * sizeof(OBJECT)))) {
			/*
			#ifdef DEBUG
				GrayDrawStrExt2B(0, 56, "Memory allocation failed!", A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
				WaitKey();
			#endif
			*/
			Error = ERR_MEM;
			return;
		}
		
		for(i = 0; i < levels[lvlnum].constant_objects; ++i) {
			objects[i].active = 1;
			objects[i].id     = constant_objects[constant_objects_offset + i].id;
			
			if(objects[i].id == TINDERBOX) {
				objects[i].counter = explosions[E_TINDERBOX].steps << TINDERBOX_STEP_SHIFT;
			} else if(objects[i].id == PIG_1 || objects[i].id == PIG_2) {
				//	the upper two bits contain mode and direction!
				objects[i].counter = (unsigned short)((random(PIG_MAX_COUNT - PIG_MIN_COUNT) + PIG_MIN_COUNT) 
						| ((((random(2) ? P_WALKING : P_WAITING) << 1) | (random(2))) << 14));
			} else{
				objects[i].counter = random((HIGH_WEIGHT-game_objects[objects[i].id].weight)*SINK_CHANCE_FACTOR);
			}
			
			/*
			#ifdef DEBUG
				sprintf(buf_str, "Init Constants. ID: %u", constant_objects[constant_objects_offset + i].id);
				GrayDrawStrExt2B(0, 56, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
				WaitKey();
			#endif
			*/
			objects[i].x      = constant_objects[constant_objects_offset + i].x << COORD_SHIFT;
			objects[i].y      = constant_objects[constant_objects_offset + i].y << COORD_SHIFT;
		}
		
		
		unsigned char tmp = 0;
		
		//	loop through the number of sets of random objects in the current level
		for(i = 0; i < levels[lvlnum].random_object_sets; ++i) {
			
			//	create given number of one object
			for(j = 0; j < random_objects[random_object_sets_offset + i].number; ++j) {
				
				//	turned on soon if there is enough place and if it doesn't collide with other objects
				objects[tmp + j + levels[lvlnum].constant_objects].active = 0;
				
				objects[tmp + j + levels[lvlnum].constant_objects].id = random_objects[random_object_sets_offset + i].id;
				
				if(objects[tmp + j + levels[lvlnum].constant_objects].id == TINDERBOX) {
					objects[tmp + j + levels[lvlnum].constant_objects].counter = explosions[E_TINDERBOX].steps << TINDERBOX_STEP_SHIFT;
				} else if(objects[tmp + j + levels[lvlnum].constant_objects].id == PIG_1 || objects[tmp + j + levels[lvlnum].constant_objects].id == PIG_2) {
					//	the upper two bits contain mode and direction!
					objects[tmp + j + levels[lvlnum].constant_objects].counter = (unsigned short)((random(PIG_MAX_COUNT - PIG_MIN_COUNT) + PIG_MIN_COUNT) 
						| ((((random(2) ? P_WALKING : P_WAITING) << 1) | (random(2))) << 14));
				} else {
					objects[tmp + j + levels[lvlnum].constant_objects].counter = random(SINK_CHANCE_FACTOR*(HIGH_WEIGHT-game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].weight));
				}
				
				/*
				#ifdef DEBUG
					sprintf(buf_str, "Test.. %u, %u", random_objects[tmp + j + levels[lvlnum].constant_objects].id, random_objects[random_object_sets_offset + i].id);
					GrayDrawStrExt2B(0, 56, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
					WaitKey();
				#endif
				*/
				
				//	avoid infinite loop if there is no place
				for(k = 255; --k;) {
					
					//	place object	
					/*
						improve: 
						- don't place over the status bar 
						- not too close to the miner
						- at least the half of it should be visible
						- shift either widths or coords
					*/
					
					objects[tmp + j + levels[lvlnum].constant_objects].x = 
						(random(LCD_WIDTH) - 
						(game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.width >> 1)) << COORD_SHIFT;
					
					objects[tmp + j + levels[lvlnum].constant_objects].y = 
						(random(LCD_HEIGHT - OBJECT_MIN_Y - (game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.height >> 1)) + 
						(STATUS_BAR_HEIGHT)) << COORD_SHIFT;
					
					//	test collision
					collide = 0;
					
					//	with constant objects
					for(l = 0; l < tmp + j + levels[lvlnum].constant_objects; ++l) {
						if((collide = Collide((objects[tmp + j + levels[lvlnum].constant_objects].x >> COORD_SHIFT) + 
																(game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.width >> 1),
																(objects[tmp + j + levels[lvlnum].constant_objects].y >> COORD_SHIFT) + 
															  (game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.height >> 1),
															  game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].radius,
															  (objects[l].x >> COORD_SHIFT) + (game_objects[objects[l].id].sprt.width >> 1),
															  (objects[l].y >> COORD_SHIFT) + (game_objects[objects[l].id].sprt.height >> 1),
															  game_objects[objects[l].id].radius
															 ))
							) {
							break;
						}
					}
					
					//	is it too close to the winch?
					if(!collide) {
						collide = Collide((objects[tmp + j + levels[lvlnum].constant_objects].x >> COORD_SHIFT) + 
																(game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.width >> 1),
																(objects[tmp + j + levels[lvlnum].constant_objects].y >> COORD_SHIFT) + 
															  (game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].sprt.height >> 1),
															  game_objects[objects[tmp + j + levels[lvlnum].constant_objects].id].radius,
															  winch_default_coords[0] >> COORD_SHIFT,
															  winch_default_coords[1] >> COORD_SHIFT,
															  OBJECT_MIN_DIST
															 );
					}
					
					//	if it doesn't collide, it becomes active
					if(!collide) {
						objects[tmp + j + levels[lvlnum].constant_objects].active = 1;
						break;
					}
				}
			}
			
			tmp += random_objects[random_object_sets_offset + i].number;
		}
		
		/*
		#ifdef DEBUG
			sprintf(buf_str, "%u, %u", random_object_nr, tmp);
			GrayDrawStrExt2B(0, 56, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
			WaitKey();
		#endif
		*/
	} else {
		
		//	if random mode
		
		//	use 'tmp_goal' to count goal
		unsigned long tmp_goal = 0;
		
		//	use 'time' as time counter
		unsigned short time = 0;
		
		object_nr = random(RANDOM_MODE_MAX_OBJECTS - RANDOM_MODE_MIN_OBJECTS) + RANDOM_MODE_MIN_OBJECTS;
		
		if(!(objects = realloc(objects, object_nr * sizeof(OBJECT)))) {
			Error = ERR_MEM;
			return;
		}
		
		for(i = 0; i < object_nr; ++i) {
			//	turned on soon if there is enough place and if it doesn't collide with other objects
			objects[i].active = 0;
			
			objects[i].id = random(OBJECT_NR);
			
			if(objects[i].id == TINDERBOX) {
				objects[i].counter = explosions[E_TINDERBOX].steps << TINDERBOX_STEP_SHIFT;
			} else if(objects[i].id == PIG_1 || objects[i].id == PIG_2) {
				//	the upper two bits contain mode and direction!
				objects[i].counter = (unsigned short)((random(PIG_MAX_COUNT - PIG_MIN_COUNT) + PIG_MIN_COUNT) 
						| ((((random(2) ? P_WALKING : P_WAITING) << 1) | (random(2))) << 14));
						/*GrayClearScreen2B_R(LightPlane, DarkPlane);
						sprintf(buf_str, "%u", objects[i].counter);
						GrayDrawStrExt2B(0,50,buf_str,
							A_CENTERED|A_NORMAL|A_SHADOWED,F_8x10,LightPlane,DarkPlane);
						while(_rowread(0));
						while(!_rowread(0));*/
			} else {
				objects[i].counter = random((HIGH_WEIGHT-game_objects[objects[i].id].weight)*SINK_CHANCE_FACTOR);
			}
			
			//	avoid infinite loop if there is no place
			for(k = 255; --k;) {
				
				//	place object	
				/*
					improve: 
					- don't place over the status bar 
					- not too close to the miner
					- at least the half of it should be visible
					- shift either widths or coords
				*/
				
				objects[i].x = 
					(random(LCD_WIDTH) - 
					(game_objects[objects[i].id].sprt.width >> 1)) << COORD_SHIFT;
				
				objects[i].y = 
					(random(LCD_HEIGHT - OBJECT_MIN_Y - (game_objects[objects[i].id].sprt.height >> 1)) + 
					(STATUS_BAR_HEIGHT)) << COORD_SHIFT;
				
				//	test collision
				collide = 0;
				
				//	with constant objects
				for(l = 0; l < i; ++l) {
					if((collide = Collide((objects[i].x >> COORD_SHIFT) + 
															(game_objects[objects[i].id].sprt.width >> 1),
															(objects[i].y >> COORD_SHIFT) + 
														  (game_objects[objects[i].id].sprt.height >> 1),
														  game_objects[objects[i].id].radius,
														  (objects[l].x >> COORD_SHIFT) + (game_objects[objects[l].id].sprt.width >> 1),
														  (objects[l].y >> COORD_SHIFT) + (game_objects[objects[l].id].sprt.height >> 1),
														  game_objects[objects[l].id].radius
														 ))
						) {
						break;
					}
				}
				
				//	is it too close to the winch?
				if(!collide) {
					collide = Collide((objects[i].x >> COORD_SHIFT) + 
															(game_objects[objects[i].id].sprt.width >> 1),
															(objects[i].y >> COORD_SHIFT) + 
														  (game_objects[objects[i].id].sprt.height >> 1),
														  game_objects[objects[i].id].radius,
														  winch_default_coords[0] >> COORD_SHIFT,
														  winch_default_coords[1] >> COORD_SHIFT,
														  OBJECT_MIN_DIST
														 );
				}
				
				//	if it doesn't collide, it becomes active
				if(!collide) {
					objects[i].active = 1;
					tmp_goal += game_objects[objects[i].id].value;
					time     += game_objects[objects[i].id].weight >> 4;
					break;
				}
			}
		}
		goal += tmp_goal >> 1;
		time >>= 2;
		
		clock.minutes = time / 60;
		clock.seconds = time % 60;
	}
}

void HandleLevelObjects() {
	
	#ifdef BACKGROUND
		//	background
		memcpy(LightBuffer + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, 
			background, 30 * LEVEL_BACKGROUND_HEIGHT);
		memcpy(DarkBuffer + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, 
			background + 30 * LEVEL_BACKGROUND_HEIGHT, 30 * LEVEL_BACKGROUND_HEIGHT);
	#else
		memset(LightBuffer + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, 
			0, 30 * LEVEL_BACKGROUND_HEIGHT);
		memset(DarkBuffer + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, 
			0, 30 * LEVEL_BACKGROUND_HEIGHT);
	#endif
	
	unsigned char i, j = 0;
	
	/*
	#ifdef DEBUG
		sprintf(buf_str, "%u", levels[lvlnum].constant_objects);
		GrayDrawStrExt2B(0, 56, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
		WaitKey();
	#endif
	*/
	/*constant_object_nr*/
	
	//	draw constant objects
	for(i = 0; i < object_nr; ++i) {
		if(objects[i].active) {
			/*
			#ifdef DEBUG
				sprintf(buf_str, "Constant: %u, %u", constant_objects[i].id, game_objects[constant_objects[i].id].sprt.width);
				GrayDrawStrExt2B(0, 56, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
				WaitKey();
			#endif
			*/
			
			if(objects[i].id == PIG_1 || objects[i].id == PIG_2) {
				unsigned short counter = 								  objects[i].counter & ~((unsigned short)0b11 << 14);					//((unsigned short)0b0011111111111111);
				unsigned char  mode    = (unsigned char)((objects[i].counter &  ((unsigned short)0b10 << 14)) >> 14);
				unsigned char  dir     = (unsigned char)((objects[i].counter &  ((unsigned short)0b01 << 14)) >> 14);
				
				/*GrayClearScreen2B_R(LightPlane, DarkPlane);
				sprintf(buf_str, "%u, %u", mode, dir);
				GrayDrawStrExt2B(0,30,buf_str,
					A_CENTERED|A_NORMAL|A_SHADOWED,F_8x10,LightPlane,DarkPlane);*/
				
				if(mode == P_WALKING) {
					objects[i].x += (dir ? PIG_SPEED : -PIG_SPEED);
					
					/*if(objects[i].x < -game_objects[objects[i].id].sprt.width || objects[i].x >= LCD_WIDTH) {
						dir ^= 1;
					}*/
					
					//	if collide with border, change direction
					if(objects[i].x >> COORD_SHIFT < -game_objects[objects[i].id].sprt.width) {
						objects[i].x = 0;
						dir = 1;
					}
					if(objects[i].x >> COORD_SHIFT >= LCD_WIDTH) {
						objects[i].x = (LCD_WIDTH - 1) << COORD_SHIFT;
						dir = 0;
					}
				}
				
				if(counter) {
					--counter;
				} else {
					//if(!random(2)) {
						mode ^= 1;
					//}
					if(!random(2)) {
						dir ^= 1;
					}
					counter = random(PIG_MAX_COUNT - PIG_MIN_COUNT) + PIG_MIN_COUNT;
				}
				
				//	the upper two bits contain mode and direction!
				objects[i].counter = (unsigned short)((counter) 
						| (((mode << 1) | dir) << 14));
				
				DrawAnimatedSprite(objects[i].x,
													 objects[i].y,
													 &game_objects[objects[i].id].sprt,
													 dir);
				
				/*sprintf(buf_str, "%u", objects[i].counter);
				GrayDrawStrExt2B(0,50,buf_str,
					A_CENTERED|A_NORMAL|A_SHADOWED,F_8x10,LightPlane,DarkPlane);
				while(_rowread(0));
				while(!_rowread(0));*/
				continue;
			} else {
				//	these objects don't sink
				if(objects[i].id != TINDERBOX && objects[i].id != ROCK_1 && objects[i].id != ROCK_2) {
					if(objects[i].counter) {
						--objects[i].counter;
					} else {
						objects[i].counter = random((HIGH_WEIGHT-game_objects[objects[i].id].weight)*SINK_CHANCE_FACTOR);
						//	sink
						objects[i].y += SINK_FACTOR*game_objects[objects[i].id].weight;
						
						if(objects[i].y >> COORD_SHIFT >= LCD_HEIGHT) {
							objects[i].active = 0;
						}
					}
				}
			}
			
			DrawSprite(objects[i].x,
								 objects[i].y,
								 &game_objects[objects[i].id].sprt);
			
			j = 1;
		} else {
			if(objects[i].id == TINDERBOX && objects[i].counter < (unsigned short)explosions[E_TINDERBOX].steps << TINDERBOX_STEP_SHIFT) {
				/*DrawAnimatedSprite(
					objects[i].x, 
					objects[i].y, 
					&explosions[E_TINDERBOX].sprt, 
					objects[i].counter >> TINDERBOX_STEP_SHIFT);*/
				unsigned char step = objects[i].counter >> TINDERBOX_STEP_SHIFT;
				GrayClipSprite32_OR_R(
					(objects[i].x >> COORD_SHIFT) + 
						((game_objects[TINDERBOX/*objects[i].id*/].sprt.width - 
						explosions[E_TINDERBOX].sprt.width) >> 1), 
					(objects[i].y >> COORD_SHIFT) + 
						((game_objects[TINDERBOX/*objects[i].id*/].sprt.height - 
						explosions[E_TINDERBOX].sprt.height) >> 1), 
					explosions[E_TINDERBOX].sprt.height, 
					explosions[E_TINDERBOX].sprt.data+(step*2+0)*explosions[E_TINDERBOX].sprt.byte_width*explosions[E_TINDERBOX].sprt.height, 
					explosions[E_TINDERBOX].sprt.data+(step*2+1)*explosions[E_TINDERBOX].sprt.byte_width*explosions[E_TINDERBOX].sprt.height, 
					//explosions[E_TINDERBOX].sprt.data+(step*3+2)*explosions[E_TINDERBOX].sprt.byte_width*explosions[E_TINDERBOX].sprt.height, 
					//explosions[E_TINDERBOX].sprt.data+(step*3+2)*explosions[E_TINDERBOX].sprt.byte_width*explosions[E_TINDERBOX].sprt.height, 
					LightBuffer, 
					DarkBuffer);
				
				//	if it has done a half of total cycles...
				if(objects[i].counter >> TINDERBOX_STEP_SHIFT == explosions[E_TINDERBOX].steps >> 3) {
					ExplodeNeighbors(i);
					//objects[i].active = 0;
				}
				++objects[i].counter;
			}
		}
	}
	
	//	if there are no objects left and nothing is on the winch
	if(!j && winch.object == NULL) {
		clock.running = 0;
	}
}

void HandleWinch() {
	if(winch.mode == W_SWINGING) {
		winch.angle += (winch.direction ? WINCH_DEFAULT_ANGLE_INC : -WINCH_DEFAULT_ANGLE_INC);
		if(winch.angle > 180 - MIN_ANGLE || winch.angle < MIN_ANGLE) {
			winch.direction ^= 1;
		}
		
		if(_keytest(RR_DOWN)) {
			winch.mode = W_DOWN;
		}
	}
	
	unsigned char i;
	short wx, wy;
	
	if(winch.mode == W_DOWN) {
		winch.length += WINCH_DEFAULT_SPEED /*>> COORD_SHIFT*/;
		
		//	end coords
		wx = (winch_default_coords[0] + 			 Cos_LK(winch.angle, winch.length /*+ (winch.radius << COORD_SHIFT)*/ /*(winch_sprt[0].height >> 1)*/)) >> COORD_SHIFT;
		wy = (winch_default_coords[1] + (short)Sin_LK(winch.angle, winch.length /*+ (winch.radius << COORD_SHIFT)*/ /*(winch_sprt[0].height >> 1)*/)) >> COORD_SHIFT;
		
		//	if winch collides with borders, reel up
		if(wx < 0 || wx >= LCD_WIDTH || wy >= LCD_HEIGHT) {
			winch.mode = W_UP;
		}
		
		//	test collision with objects
		for(i = 0; i < object_nr; ++i) {
			if(objects[i].active) {
				if(Collide(wx,
									 wy,
									 //winch.radius,
									 (winch.power_ups & (1 << P_LUCKY_CLOVER) ? WINCH_EXTRA_RADIUS : WINCH_DEFAULT_RADIUS),
									 (objects[i].x >> COORD_SHIFT) + (game_objects[objects[i].id].sprt.width >> 1),
									 (objects[i].y >> COORD_SHIFT) + (game_objects[objects[i].id].sprt.height >> 1),
									 game_objects[objects[i].id].radius)
					) {
					winch.mode = W_UP;
					//(*(winch.object = &objects[i])).active = 0;
					winch.object = &objects[i];
					if((*winch.object).id == TINDERBOX) {
						//	reset counter -> start explosion
						//	don't set inactive because it 
						//	becomes inactive during the explosion
						(*winch.object).counter = 0;
					} //else {
						(*winch.object).active = 0;
					//}
					break;
				}
			}
		}
	} else if(winch.mode == W_UP) {
		
		if(winch.object == NULL) {
			winch.length -= WINCH_EMPTY_SPEED;
		} else {
			/*WINCH_DEFAULT_SPEED*/ /*winch.strength*/
			winch.length -= ((winch.power_ups & (1 << P_STRENGTH_DRINK) ? 
												/*WINCH_DEFAULT_STRENGTH + WINCH_STRENGTH_ADD*/ WINCH_EXTRA_STRENGTH : WINCH_DEFAULT_STRENGTH) - 
												game_objects[(*winch.object).id].weight);
		}
		
		//	if it's reeled up
		if(winch.length <= WINCH_DEFAULT_LENGTH) {
			winch.length = WINCH_DEFAULT_LENGTH;
			winch.mode = W_SWINGING;
			
			//	random angle and direction
			//winch.angle = random(180 - 2*MIN_ANGLE + 1) + MIN_ANGLE;
			//winch.direction = random(2);
			
			//	check for object
			if(winch.object != NULL) {
				if((*winch.object).id == CLOCK) {
					unsigned char seconds = game_objects[(*winch.object).id].value + 
								 (game_objects[(*winch.object).id].value_variation ? 
								 random(game_objects[(*winch.object).id].value_variation) : 0);
					
					strcpy(buf_str, "Sec: ");
					itoa_ushort_10(buf_str+5, seconds);
					
					seconds += clock.seconds;
					
					clock.seconds = seconds % 60;
					clock.minutes += seconds / 60;
					update.minutes = update.seconds = 1;
					
				} else {
					unsigned short value = game_objects[(*winch.object).id].value + 
									 (game_objects[(*winch.object).id].value_variation ? 
									 random(game_objects[(*winch.object).id].value_variation) : 0);
					
					//	check for rock book, diamond polish and lucky clover
					if((*winch.object).id == ROCK_1 || (*winch.object).id == ROCK_2) {
						if(winch.power_ups & 1 << P_ROCK_BOOK) {
							value *= P_ROCK_VALUE_ADD_FACTOR;
						}
					} else if((*winch.object).id == DIAMOND) {
						if(winch.power_ups & 1 << P_DIAMOND_POLISH) {
							value += P_DIAMONT_VALUE_ADD;
						}
					} else if((*winch.object).id == GRAB_BAG) {
						if(winch.power_ups & 1 << P_LUCKY_CLOVER) {
							
							//	3 options:
							//	- more money
							//	- dynamite
							//	- strength
							
							i = random(3);
							if(i == 0) {
								value += P_LUCKY_CLOVER_ADD;
							} else if(i == 1){
								value = P_DYNAMITE;
							} else if(i == 2) {
								value = P_STRENGTH_DRINK;
							}
						}
					}
					if(value == P_DYNAMITE) {
						strcpy(buf_str, "Dynamite");
						if((winch.power_ups & 0b00001111) < MAX_DYNAMITES) {
							++winch.power_ups;
						}
					} else if(value == P_STRENGTH_DRINK) {
						strcpy(buf_str, "Strength");
						winch.power_ups |= 1 << P_STRENGTH_DRINK;
					} else {
						buf_str[0] = '$';
						itoa_ushort_10(buf_str+1, value);
						money += value;
						update.money = 1;
					}
				}
				winch.object = NULL;
				
				
				//	money animation
				
				update.anim = 1;
			}
		}
	}
	
	
	//	end coords
	wx = (winch_default_coords[0] + 			 Cos_LK(winch.angle, winch.length - (winch_sprt[0].height << (COORD_SHIFT - 1)))) >> COORD_SHIFT;
	wy = (winch_default_coords[1] + (short)Sin_LK(winch.angle, winch.length - (winch_sprt[0].height << (COORD_SHIFT - 1)))) >> COORD_SHIFT;
	
	GrayFastDrawLine2B(winch_default_coords[0] >> COORD_SHIFT,
										 winch_default_coords[1] >> COORD_SHIFT,
										 wx,
										 wy,
										 COLOR_BLACK,
										 LightBuffer,DarkBuffer
	);
	
	//	end coords
	wx = (winch_default_coords[0] + 			 Cos_LK(winch.angle, winch.length)) /*>> COORD_SHIFT*/;
	wy = (winch_default_coords[1] + (short)Sin_LK(winch.angle, winch.length)) /*>> COORD_SHIFT*/;
	
	//	draw winch: angle/10
	//unsigned char angle = winch.angle / 10;
	
	DrawAnimatedSprite(wx - (winch_sprt[0].width  << (COORD_SHIFT - 1)), 
										 wy - (winch_sprt[0].height << (COORD_SHIFT - 1)),
										 //&winch_sprt[winch.mode == W_UP],
										 &(SPRITE) {
										 		(winch.mode == W_UP ? winch_closed : winch_open),
										 		winch_sprt[winch.mode == W_UP].width,
										 		winch_sprt[winch.mode == W_UP].byte_width,
										 		winch_sprt[winch.mode == W_UP].height
										 },
										 winch.angle / 10);
									
	
	
	//	if there is an object, draw it
	if(winch.mode == W_UP && winch.object != NULL) {	//	/*winch.mode == W_UP*/
		const SPRITE *sprt = ((*winch.object).id == TINDERBOX ? &tinderbox_cover_sprt : &game_objects[(*winch.object).id].sprt);
		
		//	end coords
		wx = (winch_default_coords[0] + 			 Cos_LK(winch.angle, winch.length + (sprt->height << (COORD_SHIFT - 1)))) >> COORD_SHIFT;
		wy = (winch_default_coords[1] + (short)Sin_LK(winch.angle, winch.length + (sprt->height << (COORD_SHIFT - 1)))) >> COORD_SHIFT;
		
		short x = (wx - (sprt->width  >> 1));
		short y = (wy - (sprt->height >> 1));
		DrawSprite(x << COORD_SHIFT,
							 y << COORD_SHIFT,
							 sprt);
	}
}



void HandleDynamites() {
	static unsigned char is_throwing = 0, length, expl_count = 0;
	static short dx, dy;
	//	throw dynamite
	if(!is_throwing && _keytest(RR_HAND) && 
		//#ifndef DEBUG
			winch.power_ups & 0b00001111 /*dynamites*/ && 
		//#endif
		winch.mode == W_UP && winch.object != NULL) {
		//#ifndef DEBUG
			//--dynamites;
			--winch.power_ups;
		//#endif
		is_throwing = 1;
		length = 0;
	}
	//	is_throwing: 0 - isn't throwing, 1 - throwing, 2 - 5 explosion
	if(is_throwing == 1) {
		
		//	coords of the dynamite
		dx = ((winch_default_coords[0] >> COORD_SHIFT) + 				Cos_LK(winch.angle, length) - 8) << COORD_SHIFT;
		dy = ((winch_default_coords[1] >> COORD_SHIFT) + (short)Sin_LK(winch.angle, length)) << COORD_SHIFT;
		DrawSprite((dx /*- 8*/), dy, &dynamite_sprts[1]);
		length += DYNAMITE_THROW_SPEED;
		
		if(length >= winch.length >> COORD_SHIFT) {
			//	perform explosion and erase object
			is_throwing = 2;
			winch.object = NULL;
			expl_count = 0;
			
			//	coords of the dynamite
			dx = (winch_default_coords[0]) + 				Cos_LK(winch.angle, length << COORD_SHIFT) - (explosions[E_DYNAMITE].sprt.width  << (COORD_SHIFT - 1));
			dy = (winch_default_coords[1]) + (short)Sin_LK(winch.angle, length << COORD_SHIFT) - (explosions[E_DYNAMITE].sprt.height << (COORD_SHIFT - 1));
		}
	} else if(is_throwing == 2) {
		/*DrawSprite( dx, 
								dy, 
								&(SPRITE){
							 		(const void *)explosions[E_DYNAMITE].data+
							 		(expl_count >> 2) * 3 * explosions[E_DYNAMITE].byte_width * explosions[E_DYNAMITE].height,
							 		explosions[E_DYNAMITE].width,
							 		explosions[E_DYNAMITE].byte_width,
							 		explosions[E_DYNAMITE].height
								});*/
		DrawAnimatedSprite(
								dx, 
								dy, 
								&explosions[E_DYNAMITE].sprt,
								expl_count >> 2);
		if((expl_count++) >> 2 > 4) {
			is_throwing = 0;
		}
	}
}



void ExplodeNeighbors(unsigned char n) {
	unsigned char i;
	
	//	objects[n] won't be tested with itself since its counter isn't expired
	for(i = 0; i < object_nr; ++i) {
		if(i != n) {
			//	I assume objects[n].id == TINDERBOX
			if(Collide((objects[n].x >> COORD_SHIFT) + (game_objects[TINDERBOX/*objects[n].id*/].sprt.width  >> 1),
								 (objects[n].y >> COORD_SHIFT) + (game_objects[TINDERBOX/*objects[n].id*/].sprt.height >> 1),
								 //game_objects[/*TINDERBOX*/objects[n].id].radius,
								 TINDERBOX_EXPLOSION_RADIUS,
								 (objects[i].x >> COORD_SHIFT) + (game_objects[/*TINDERBOX*/objects[i].id].sprt.width  >> 1),
								 (objects[i].y >> COORD_SHIFT) + (game_objects[/*TINDERBOX*/objects[i].id].sprt.height >> 1),
								 (objects[i].id == TINDERBOX ? TINDERBOX_EXPLOSION_RADIUS : game_objects[/*TINDERBOX*/objects[i].id].radius)
								 /*TINDERBOX_EXPLOSION_RADIUS*/)
					) {
				if(objects[i].id == TINDERBOX && objects[i].active /*&& objects[i].counter == (unsigned short)explosions[E_TINDERBOX].steps << TINDERBOX_STEP_SHIFT*/) {
					//	reset counter -> start explosion
					objects[i].counter = 0;
					//ExplodeNeighbors(i);
				} //else {
					objects[i].active = 0;
				//}
			}
		}
	}
}