// Header File
// Created 28.02.2008; 15:00:37

#ifndef OBJECTS_H
#define OBJECTS_H

#ifdef BACKGROUND

	#define BACKGROUND_NR	3
	const unsigned char *backgrounds[BACKGROUND_NR][2] = {
		{_bg_0_l, _bg_0_d},
		{_bg_1_l, _bg_1_d},
		{_bg_2_l, _bg_2_d},
	};

#endif

typedef struct {
	const SPRITE   sprt;
	unsigned short radius;
	unsigned short value;
	unsigned short value_variation;
	unsigned short weight;
	//unsigned short weight_variation;
} GAME_OBJECT;


enum Objects {
	NUGGET_1, 
	NUGGET_2, 
	NUGGET_3, 
	DIAMOND, 
	GRAB_BAG, 
	TINDERBOX, 
	CLOCK, 
	PIG_1, 
	PIG_2,
	ROCK_1,
	ROCK_2,
	SKULL,
	BONE
};

#define OBJECT_NR 13
const GAME_OBJECT game_objects[OBJECT_NR] = {
	{{_nugget_1,   8, 1,  7},  4,  50,  20,  50, /* 10*/},
	{{_nugget_2,  13, 2, 12},  6, 200, 100, 200, /* 50*/},
	{{_nugget_3,  32, 4, 32}, 16, 300, 200, 420, /*100*/},
	{{_diamond,   10, 2,  8},  5, 300,  50,  40, /*100*/},
	{{_grab_bag,  15, 2, 17},  7, 200,  20,  70, /*100*/},
	{{_tinderbox, 16, 2, 16},  8,   4,   0,  30, /*100*/},
	{{_clock,     15, 2, 15},  7,  20,  20, 150, /*100*/},	// beware of value+variation-1+60 <= 255
	{{_pig_1,     16, 2, 10},  9,   5,   5,  80, /*100*/},
	{{_pig_2,     20, 4, 10},  9, 405,  55, 110, /*100*/},
	{{_rock_1,    13, 2, 11},  7,  10,   5, 350, /*100*/},
	{{_rock_2,    18, 4, 16},  9,  20,  10, 420, /*100*/},
	{{_skull,     21, 4, 20}, 10,  10,  10, 120, /*100*/},
	{{_bone,      24, 4, 16}, 10,   4,   0,  50, /*100*/},
};


/*****************************************************************************/


/*
	The difference between constant objects and random ones is that
	random objects are placed in runtime and only their id is given
	whereas constant objects have a constant place and id.
	
	Each level contains the number of constant and random objects
	(actually sets of random objects) that belong to it.
*/

typedef struct {
	unsigned char id;
	short x, y;
} CONSTANT_OBJECT;

typedef struct {
	unsigned char id;
	unsigned char number;
} RANDOM_OBJECT;


#endif